Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3704)
@@ -544,29 +646,21 @@
 !--       times. 
           IF ( vmea(l)%trajectory )  THEN
-             CALL netcdf_data_input_var( e_utm, char_eutm // TRIM( dum ), id_vm,  &
+             CALL netcdf_data_input_var( e_utm, char_eutm // TRIM( dum ),      &
+                                         vmea_general%id_vm,                   &
                                          0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
-             CALL netcdf_data_input_var( n_utm, char_nutm // TRIM( dum ), id_vm,  &
+             CALL netcdf_data_input_var( n_utm, char_nutm // TRIM( dum ),      &
+                                         vmea_general%id_vm,                   &
                                          0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
-             CALL netcdf_data_input_var( z_ag, char_zag // TRIM( dum ), id_vm,  &
+             CALL netcdf_data_input_var( z_ag, char_zag // TRIM( dum ),        &
+                                         vmea_general%id_vm,                   &
                                          0, dim_ntime-1, 0, vmea(l)%ntraj-1 )
           ELSE
-             CALL netcdf_data_input_var( e_utm(1,:), char_eutm // TRIM( dum ), id_vm )
-             CALL netcdf_data_input_var( n_utm(1,:), char_nutm // TRIM( dum ), id_vm )
-             CALL netcdf_data_input_var( z_ag(1,:),  char_zag  // TRIM( dum ), id_vm )
-          ENDIF
-!
-!-- For testing:
-          e_utm = e_utm - e_utm(1,1)
-          n_utm = n_utm - n_utm(1,1)
-          
-!             
-!--       First, compute relative x- and y-coordinates with respect to the 
-!--       lower-left origin of the model domain, which is the difference 
-!--       betwen UTM coordinates.  
-!           e_utm(t,1:vmea(l)%dim_t(t)) = e_utm(t,1:vmea(l)%dim_t(t))            &
-!                                       - init_model%origin_x
-!           n_utm(t,1:vmea(l)%dim_t(t)) = n_utm(t,1:vmea(l)%dim_t(t))            &
-!                                       - init_model%origin_y
-
+             CALL netcdf_data_input_var( e_utm(1,:), char_eutm // TRIM( dum ), &
+                                         vmea_general%id_vm )
+             CALL netcdf_data_input_var( n_utm(1,:), char_nutm // TRIM( dum ), &
+                                         vmea_general%id_vm )
+             CALL netcdf_data_input_var( z_ag(1,:),  char_zag  // TRIM( dum ), &
+                                         vmea_general%id_vm )
+          ENDIF         
 !
 !--       Based on UTM coordinates, check if the measurement station or parts
@@ -575,4 +669,11 @@
           meas_flag = 0
           DO  t = 1, vmea(l)%ntraj
+!             
+!--          First, compute relative x- and y-coordinates with respect to the 
+!--          lower-left origin of the model domain, which is the difference 
+!--          betwen UTM coordinates. Note, if the origin is not correct, the
+!--          virtual sites will be misplaced. 
+             e_utm(t,1:dim_ntime) = e_utm(t,1:dim_ntime) - init_model%origin_x
+             n_utm(t,1:dim_ntime) = n_utm(t,1:dim_ntime) - init_model%origin_y
 !
 !--          Determine the individual time coordinate length for each station and
@@ -580,5 +681,6 @@
 !--          are merged into one file but they do not have the same number of
 !--          points in time, hence, missing values may occur and cannot be 
-!--          processed further.
+!--          processed further. This is actually a work-around for the specific
+!--          (UC)2 dataset, but it won't harm in anyway. 
              vmea(l)%dim_t(t) = 0
              DO  n = 1, dim_ntime
@@ -587,5 +689,4 @@
                      z_ag(t,n)  /= fill_zag )  vmea(l)%dim_t(t) = n
              ENDDO
-
 !
 !--          Compute grid indices relative to origin and check if these are
@@ -612,9 +713,18 @@
 !--                surrounding coordinate points, but first check whether the
 !--                surrounding coordinate points are on the subdomain. 
-                   kl = MERGE( ks-1, ks, ks-1 >= nzb  .AND. ks-1 > ksurf )
-                   ku = MERGE( ks+1, ks, ks+1 <= nzt+1 )
-                 
-                   meas_flag(kl:ku,js-1:js+1,is-1:is+1) =                      &
-                               IBSET( meas_flag(kl:ku,js-1:js+1,is-1:is+1), 0 ) 
+                   kl = MERGE( ks-1, ks, ks-1 >= nzb  .AND. ks-1 >= ksurf )
+                   ku = MERGE( ks+1, ks, ks+1 < nzt+1 )
+                 
+                   DO  i = is-1, is+1
+                      DO  j = js-1, js+1
+                         DO  k = kl, ku
+                            meas_flag(k,j,i) = MERGE(                          &
+                                             IBSET( meas_flag(k,j,i), 0 ),     &
+                                             0,                                &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                                    )
+                         ENDDO
+                      ENDDO
+                   ENDDO
                 ENDIF
              ENDDO
@@ -622,54 +732,121 @@
           ENDDO
 !
-!--       Based on the flag array count the number of observation points.
+!--       Based on the flag array count the number of of sampling coordinates.
+!--       Please note, sampling coordinates in atmosphere and soil may be 
+!--       different, as within the soil all levels will be measured.           
+!--       Hence, count individually. Start with atmoshere.
           ns = 0
-          DO  is = nxl-1, nxr+1
-             DO  js = nys-1, nyn+1
-                DO  ks = nzb, nzt+1
-                   ns = ns + MERGE( 1, 0, BTEST( meas_flag(ks,js,is), 0 ) )
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                DO  k = nzb, nzt+1
+                   ns = ns + MERGE( 1, 0, BTEST( meas_flag(k,j,i), 0 ) )
                 ENDDO
              ENDDO
           ENDDO
+          
 !
 !--       Store number of observation points on subdomain and allocate index
-!--       arrays.
+!--       arrays as well as array containing height information.
           vmea(l)%ns = ns
-          ns = 0
           
           ALLOCATE( vmea(l)%i(1:vmea(l)%ns) )
           ALLOCATE( vmea(l)%j(1:vmea(l)%ns) )
           ALLOCATE( vmea(l)%k(1:vmea(l)%ns) )
+          ALLOCATE( vmea(l)%z_ag(1:vmea(l)%ns) )          
 !
 !--       Based on the flag array store the grid indices which correspond to 
 !--       the observation coordinates. 
-          DO  is = nxl-1, nxr+1
-             DO  js = nys-1, nyn+1
-                DO  ks = nzb, nzt+1
-                   IF ( BTEST( meas_flag(ks,js,is), 0 ) )  THEN
+          ns = 0
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                DO  k = nzb, nzt+1
+                   IF ( BTEST( meas_flag(k,j,i), 0 ) )  THEN
                       ns = ns + 1
-                      vmea(l)%i(ns) = is
-                      vmea(l)%j(ns) = js
-                      vmea(l)%k(ns) = ks
+                      vmea(l)%i(ns) = i
+                      vmea(l)%j(ns) = j
+                      vmea(l)%k(ns) = k
+                      vmea(l)%z_ag(ns)  = zu(k) -                              &
+                                   zw(get_topography_top_index_ji( j, i, 's' ))
                    ENDIF
                 ENDDO
              ENDDO
           ENDDO
+!
+!--       Same for the soil. Based on the flag array, count the number of 
+!--       sampling coordinates in soil. Sample at all soil levels in this case. 
+          IF ( vmea(l)%soil_sampling )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
+                      IF ( surf_lsm_h%start_index(j,i) <=                      &
+                           surf_lsm_h%end_index(j,i) )  THEN
+                         vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
+                                                      nzt_soil - nzb_soil + 1 
+                      ENDIF
+                      IF ( surf_usm_h%start_index(j,i) <=                      &
+                           surf_usm_h%end_index(j,i) )  THEN
+                         vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
+                                                      nzt_wall - nzb_wall + 1 
+                      ENDIF
+                   ENDIF
+                ENDDO
+             ENDDO
+          ENDIF         
+!
+!--       Allocate index arrays as well as array containing height information 
+!--       for soil.
+          IF ( vmea(l)%soil_sampling )  THEN
+             ALLOCATE( vmea(l)%i_soil(1:vmea(l)%ns_soil) )
+             ALLOCATE( vmea(l)%j_soil(1:vmea(l)%ns_soil) )
+             ALLOCATE( vmea(l)%k_soil(1:vmea(l)%ns_soil) )
+             ALLOCATE( vmea(l)%depth(1:vmea(l)%ns_soil) )
+          ENDIF     
+!
+!--       For soil, store the grid indices.
+          ns = 0
+          IF ( vmea(l)%soil_sampling )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
+                      IF ( surf_lsm_h%start_index(j,i) <=                      &
+                           surf_lsm_h%end_index(j,i) )  THEN
+                         m = surf_lsm_h%start_index(j,i)
+                         DO  k = nzb_soil, nzt_soil
+                            ns = ns + 1
+                            vmea(l)%i_soil(ns) = i
+                            vmea(l)%j_soil(ns) = j
+                            vmea(l)%k_soil(ns) = k
+                            vmea(l)%depth(ns)  = zs(k)
+                         ENDDO
+                      ENDIF
+                      
+                      IF ( surf_usm_h%start_index(j,i) <=                      &
+                           surf_usm_h%end_index(j,i) )  THEN
+                         m = surf_usm_h%start_index(j,i)
+                         DO  k = nzb_wall, nzt_wall
+                            ns = ns + 1
+                            vmea(l)%i_soil(ns) = i
+                            vmea(l)%j_soil(ns) = j
+                            vmea(l)%k_soil(ns) = k
+                            vmea(l)%depth(ns)  = surf_usm_h%zw(k,m)
+                         ENDDO
+                      ENDIF
+                   ENDIF
+                ENDDO
+             ENDDO
+          ENDIF
+!
+!--       Allocate array to save the sampled values.
+          ALLOCATE( vmea(l)%measured_vars(1:vmea(l)%ns,1:vmea(l)%nvar) )
           
-!           write(9,*) l, "NS: ", ns
-!           IF ( ns > 0 )   THEN
-!              write(9,*) "i ", vmea(l)%i
-!              write(9,*) "j ", vmea(l)%j
-!              write(9,*) "k ", vmea(l)%k
-!              write(9,*)
-!           ENDIF
-!
-!--       Allocate array to save the sampled values.
-!--       Todo: Is it better to allocate for all variables at a station
-!--       and store all the values before writing, or sample the variables
-!--       directly in the data output?
-          ALLOCATE( vmea(l)%measured_vars(1:vmea(l)%nvar,1:vmea(l)%ns) )
-!
-!--       Initialize with _FillValue
-          vmea(l)%measured_vars(1:vmea(l)%nvar,1:vmea(l)%ns) = vmea(l)%fillout
+          IF ( vmea(l)%soil_sampling )                                         &
+             ALLOCATE( vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,           &
+                                                  1:vmea(l)%nvar) )
+!
+!--       Initialize with _FillValues
+          vmea(l)%measured_vars(1:vmea(l)%ns,1:vmea(l)%nvar) = vmea(l)%fillout
+          IF ( vmea(l)%soil_sampling )                                         &
+             vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,1:vmea(l)%nvar) =    &
+                                                                vmea(l)%fillout
 !
 !--       Deallocate temporary coordinate arrays
@@ -677,16 +854,47 @@
           IF ( ALLOCATED( n_utm ) )  DEALLOCATE( n_utm )
           IF ( ALLOCATED( z_ag  ) )  DEALLOCATE( z_ag  )
+          IF ( ALLOCATED( z_ag  ) )  DEALLOCATE( vmea(l)%dim_t )
        ENDIF
     ENDDO
-!     flush(9)
-    
 !
 !-- Close input file for virtual measurements. Therefore, just call 
 !-- the read attribute routine with the "close" option. 
-    CALL netcdf_data_input_att( nvm, char_numstations, id_vm, '',              &
+    CALL netcdf_data_input_att( vmea_general%nvm, char_numstations,            &
+                                vmea_general%id_vm, '',                        &
                                 global_attribute, 'close', '' )
+!
+!-- Sum-up the number of observation coordiates, for atmosphere first. 
+!-- This is actually only required for data output.
+    ALLOCATE( ns_all(1:vmea_general%nvm) )
+    ns_all = 0    
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( vmea(:)%ns, ns_all(:), vmea_general%nvm, MPI_INTEGER,  &
+                        MPI_SUM, comm2d, ierr )
+#else
+    ns_all(:) = vmea(:)%ns
+#endif
+    vmea(:)%ns_tot = ns_all(:)
+!
+!-- Now for soil
+    ns_all = 0    
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( vmea(:)%ns_soil, ns_all(:), vmea_general%nvm,          &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
+#else
+    ns_all(:) = vmea(:)%ns_soil
+#endif
+    vmea(:)%ns_soil_tot = ns_all(:)
+    
+    DEALLOCATE( ns_all )
 !                               
 !-- Dellocate flag array
     DEALLOCATE( meas_flag )
+!
+!-- Initialize binary data output of virtual measurements.
+!-- Open binary output file.
+    CALL check_open( 27 )
+!
+!-- Output header information.
+    CALL vm_data_output
         
   END SUBROUTINE vm_init
@@ -696,4 +904,150 @@
 ! Description:
 ! ------------
+!> Binary data output.
+!------------------------------------------------------------------------------!
+  SUBROUTINE vm_data_output
+    
+     USE pegrid
+    
+     IMPLICIT NONE
+         
+     INTEGER(iwp) ::  i         !< running index over IO blocks    
+     INTEGER(iwp) ::  l         !< running index over all stations
+     INTEGER(iwp) ::  n         !< running index over all measured variables at a station
+!
+!--  Header output on each PE
+     IF ( init )  THEN
+
+        DO  i = 0, io_blocks-1
+           IF ( i == io_group )  THEN
+              WRITE ( 27 )  'number of measurements            '
+              WRITE ( 27 )  vmea_general%nvm
+
+              DO  l = 1, vmea_general%nvm
+                 WRITE ( 27 )  'site                              '
+                 WRITE ( 27 )  vmea(l)%site
+                 WRITE ( 27 )  'file                              '
+                 WRITE ( 27 )  vmea(l)%filename_original
+                 WRITE ( 27 )  'feature_type                      '
+                 WRITE ( 27 )  vmea(l)%feature_type
+                 WRITE ( 27 )  'origin_x_obs                      '
+                 WRITE ( 27 )  vmea(l)%origin_x_obs
+                 WRITE ( 27 )  'origin_y_obs                      '
+                 WRITE ( 27 )  vmea(l)%origin_y_obs
+                 WRITE ( 27 )  'total number of observation points'                               
+                 WRITE ( 27 )  vmea(l)%ns_tot
+                 WRITE ( 27 )  'number of measured variables      '
+                 WRITE ( 27 )  vmea(l)%nvar
+                 WRITE ( 27 )  'variables                         '
+                 WRITE ( 27 )  vmea(l)%measured_vars_name(:)
+                 WRITE ( 27 )  'number of observation points      '
+                 WRITE ( 27 )  vmea(l)%ns
+                 WRITE ( 27 )  'E_UTM                             '
+                 WRITE ( 27 )  init_model%origin_x +                           &
+                        REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx
+                 WRITE ( 27 )  'N_UTM                             '
+                 WRITE ( 27 )  init_model%origin_y +                           &
+                        REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy
+                 WRITE ( 27 )  'Z_AG                              '
+                 WRITE ( 27 )  vmea(l)%z_ag(1:vmea(l)%ns)
+                 WRITE ( 27 )  'soil sampling                     '
+                 WRITE ( 27 )  MERGE( 'yes                               ',    &
+                                      'no                                ',    &
+                                      vmea(l)%soil_sampling )
+ 
+                 IF ( vmea(l)%soil_sampling )  THEN                 
+                    WRITE ( 27 )  'total number of soil points       '                               
+                    WRITE ( 27 )  vmea(l)%ns_soil_tot
+                    print*, "vmea(l)%ns_soil_tot", vmea(l)%ns_soil_tot
+                    WRITE ( 27 )  'number of soil points             '
+                    WRITE ( 27 )  vmea(l)%ns_soil
+                    WRITE ( 27 )  'E_UTM soil                        '
+                    WRITE ( 27 )  init_model%origin_x +                        &
+                           REAL( vmea(l)%i_soil(1:vmea(l)%ns_soil) + 0.5_wp,   &
+                                 KIND = wp ) * dx
+                    WRITE ( 27 )  'N_UTM soil                        '
+                    WRITE ( 27 )  init_model%origin_y +                        &
+                           REAL( vmea(l)%j_soil(1:vmea(l)%ns_soil) + 0.5_wp,   &
+                                 KIND = wp ) * dy
+                    WRITE ( 27 )  'DEPTH                             '
+                    WRITE ( 27 )  vmea(l)%depth(1:vmea(l)%ns_soil)
+                 ENDIF
+              ENDDO
+
+           ENDIF
+        ENDDO
+        
+#if defined( __parallel )
+        CALL MPI_BARRIER( comm2d, ierr )
+#endif
+!
+!--     After header information is written, set control flag to .FALSE.
+        init = .FALSE.
+!
+!--  Data output at each measurement timestep on each PE
+     ELSE
+        DO  i = 0, io_blocks-1
+
+           IF ( i == io_group )  THEN
+              WRITE( 27 )  'output time                       '
+              WRITE( 27 )  time_since_reference_point
+              DO  l = 1, vmea_general%nvm
+!
+!--              Skip binary writing if no observation points are defined on PE
+                 IF ( vmea(l)%ns < 1  .AND.  vmea(l)%ns_soil < 1)  CYCLE                 
+                 DO  n = 1, vmea(l)%nvar
+                    WRITE( 27 )  vmea(l)%measured_vars_name(n)
+                    IF ( vmea(l)%soil_sampling  .AND.                           &
+                         ANY( TRIM( vmea(l)%measured_vars_name(n))  ==          &
+                              soil_vars ) )  THEN                   
+                       WRITE( 27 )  vmea(l)%measured_vars_soil(:,n)
+                    ELSE
+                       WRITE( 27 )  vmea(l)%measured_vars(:,n)
+                    ENDIF
+                 ENDDO
+           
+              ENDDO
+           ENDIF
+        ENDDO
+#if defined( __parallel )
+        CALL MPI_BARRIER( comm2d, ierr )
+#endif
+     ENDIF
+  
+  END SUBROUTINE vm_data_output  
+  
+  
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Write end-of-file statement as last action.
+!------------------------------------------------------------------------------!
+  SUBROUTINE vm_last_actions
+    
+     USE pegrid
+    
+     IMPLICIT NONE
+         
+     INTEGER(iwp) ::  i         !< running index over IO blocks    
+     INTEGER(iwp) ::  l         !< running index over all stations
+     INTEGER(iwp) ::  n         !< running index over all measured variables at a station
+ 
+     DO  i = 0, io_blocks-1
+        IF ( i == io_group )  THEN
+           WRITE( 27 )  'EOF                               '
+        ENDIF
+     ENDDO
+#if defined( __parallel )
+        CALL MPI_BARRIER( comm2d, ierr )
+#endif
+!
+!--  Close binary file
+     CALL close_file( 27 )
+  
+  END SUBROUTINE vm_last_actions 
+  
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Sampling of the actual quantities along the observation coordinates
 !------------------------------------------------------------------------------!
@@ -714,21 +1068,29 @@
      IMPLICIT NONE
      
-!     CHARACTER(LEN=10) ::  trimvar !< dummy for the measured variable name
+     CHARACTER(LEN=10) ::  trimvar !< dummy for the measured variable name
       
-     INTEGER(iwp) ::  i  !< grid index in x-direction
-     INTEGER(iwp) ::  j  !< grid index in y-direction
-     INTEGER(iwp) ::  k  !< grid index in z-direction
-     INTEGER(iwp) ::  l  !< running index over the number of stations
-     INTEGER(iwp) ::  m  !< running index over all virtual observation coordinates
-     INTEGER(iwp) ::  mm !< index of surface element which corresponds to the virtual observation coordinate
-     INTEGER(iwp) ::  n  !< running index over all measured variables at a station
-     INTEGER(iwp) ::  nn !< running index over the number of chemcal species
-!
-!--  Loop over all stations. For each possible variable loop over all 
-!--  observation points
-     DO  l = 1, nvm
-!
-!--     Loop over all measured variables at this station. Please note, 
-!--     velocity components are interpolated onto scalar grid.  
+     INTEGER(iwp) ::  i         !< grid index in x-direction
+     INTEGER(iwp) ::  j         !< grid index in y-direction
+     INTEGER(iwp) ::  k         !< grid index in z-direction
+     INTEGER(iwp) ::  ind_chem  !< dummy index to identify chemistry variable and translate it from (UC)2 standard to interal naming
+     INTEGER(iwp) ::  l         !< running index over the number of stations
+     INTEGER(iwp) ::  m         !< running index over all virtual observation coordinates
+     INTEGER(iwp) ::  mm        !< index of surface element which corresponds to the virtual observation coordinate
+     INTEGER(iwp) ::  n         !< running index over all measured variables at a station
+     INTEGER(iwp) ::  nn        !< running index over the number of chemcal species
+     
+     LOGICAL ::  match_lsm !< flag indicating natural-type surface
+     LOGICAL ::  match_usm !< flag indicating urban-type surface
+!
+!--  Loop over all sites. 
+     DO  l = 1, vmea_general%nvm
+!
+!--     At the beginning, set _FillValues
+        IF ( ALLOCATED( vmea(l)%measured_vars      ) )                         &
+           vmea(l)%measured_vars      = vmea(l)%fillout 
+        IF ( ALLOCATED( vmea(l)%measured_vars_soil ) )                         &
+           vmea(l)%measured_vars_soil = vmea(l)%fillout 
+!
+!--     Loop over all variables measured at this site.  
         DO  n = 1, vmea(l)%nvar
         
@@ -741,9 +1103,9 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(n,m) = pt(k,j,i)
+                       vmea(l)%measured_vars(m,n) = pt(k,j,i)
                     ENDDO
                  ENDIF
                  
-              CASE ( 'ta', 't_va' )
+              CASE ( 'ta' )
                  IF ( .NOT. neutral )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -751,7 +1113,9 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(n,m) = pt(k,j,i) * exner( k )
+                       vmea(l)%measured_vars(m,n) = pt(k,j,i) * exner( k )
                     ENDDO
                  ENDIF
+              
+              CASE ( 't_va' )
                  
               CASE ( 'hus', 'haa' )
@@ -761,5 +1125,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(n,m) = q(k,j,i)
+                       vmea(l)%measured_vars(m,n) = q(k,j,i)
                     ENDDO
                  ENDIF
@@ -770,5 +1134,5 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(n,m) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
                  ENDDO
                  
@@ -778,13 +1142,13 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(n,m) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
                  ENDDO
                  
               CASE ( 'w' )
                  DO  m = 1, vmea(l)%ns
-                    k = vmea(l)%k(m)
+                    k = MAX ( 1, vmea(l)%k(m) )  
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(n,m) = w(k,j,i) !0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
                  ENDDO
                  
@@ -794,5 +1158,5 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(n,m) = SQRT(                         &
+                    vmea(l)%measured_vars(m,n) = SQRT(                         &
                                    ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 + &
                                    ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) )**2   &
@@ -806,17 +1170,86 @@
                     i = vmea(l)%i(m)
                     
-                    vmea(l)%measured_vars(n,m) = ATAN2(                        &
+                    vmea(l)%measured_vars(m,n) = ATAN2(                        &
                                        - 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ),   &
                                        - 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )    &
                                                       ) * 180.0_wp / pi
                  ENDDO
-!
-!--           MS: list of variables needs extension.
-              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mcco', 'mcco2', 'mcbcda',  &
-                     'ncaa', 'mfco2', 'mfco', 'mfch4', 'mfnh3', 'mfno',        &
-                     'mfno2', 'mfso2', 'mfh20', 'tr03' )
-                 IF ( air_chemistry )  THEN                 
+                 
+              CASE ( 'utheta' )
+                 DO  m = 1, vmea(l)%ns
+                    k = vmea(l)%k(m)
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
+                                                 ( u(k,j,i) + u(k,j,i+1) ) *   &
+                                                   pt(k,j,i)
+                 ENDDO
+                 
+              CASE ( 'vtheta' )
+                 DO  m = 1, vmea(l)%ns
+                    k = vmea(l)%k(m)
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
+                                                 ( v(k,j,i) + v(k,j+1,i) ) *   &
+                                                   pt(k,j,i)
+                 ENDDO
+                 
+              CASE ( 'wtheta' )
+                 DO  m = 1, vmea(l)%ns
+                    k = MAX ( 1, vmea(l)%k(m) )
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
+                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
+                                                   pt(k,j,i)
+                 ENDDO
+                 
+              CASE ( 'uw' )
+                 DO  m = 1, vmea(l)%ns
+                    k = MAX ( 1, vmea(l)%k(m) )
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
+                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
+                                                 ( u(k,j,i)   + u(k,j,i+1) )
+                 ENDDO
+                 
+              CASE ( 'vw' )
+                 DO  m = 1, vmea(l)%ns
+                    k = MAX ( 1, vmea(l)%k(m) )
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
+                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
+                                                 ( v(k,j,i)   + v(k,j+1,i) )
+                 ENDDO
+                 
+              CASE ( 'uv' )
+                 DO  m = 1, vmea(l)%ns
+                    k = MAX ( 1, vmea(l)%k(m) )
+                    j = vmea(l)%j(m)
+                    i = vmea(l)%i(m)
+                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
+                                                 ( u(k,j,i)   + u(k,j,i+1) ) * &
+                                                 ( v(k,j,i)   + v(k,j+1,i) )
+                 ENDDO
+!
+!--           List of variables may need extension.
+              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mfco', 'mfno', 'mfno2',    & 
+                     'tro3' )                     
+                 IF ( air_chemistry )  THEN
+!
+!--                 First, search for the measured variable in the chem_vars 
+!--                 list, in order to get the internal name of the variable. 
+                    DO  nn = 1, UBOUND( chem_vars, 2 )
+                       IF ( TRIM( vmea(l)%measured_vars_name(m) ) ==           &
+                            TRIM( chem_vars(0,nn) ) )  ind_chem = nn
+                    ENDDO
+!
+!--                 Run loop over all chemical species, if the measured 
+!--                 variable matches the interal name, sample the variable.
                     DO  nn = 1, nspec                    
-                       IF ( TRIM( vmea(l)%measured_vars_name(m) ) ==           &
+                       IF ( TRIM( chem_vars(1,ind_chem) ) ==                   &
                             TRIM( chem_species(nn)%name ) )  THEN                            
                           DO  m = 1, vmea(l)%ns             
@@ -824,5 +1257,5 @@
                              j = vmea(l)%j(m)
                              i = vmea(l)%i(m)                    
-                             vmea(l)%measured_vars(n,m) =                      &
+                             vmea(l)%measured_vars(m,n) =                      &
                                                    chem_species(nn)%conc(k,j,i)
                           ENDDO
@@ -843,13 +1276,13 @@
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_def_h(0)%us(mm)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%us(mm)
                     ENDDO
                     DO  mm = surf_lsm_h%start_index(j,i),                      &
                              surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_lsm_h%us(mm)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%us(mm)
                     ENDDO
                     DO  mm = surf_usm_h%start_index(j,i),                      &
                              surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_usm_h%us(mm)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%us(mm)
                     ENDDO
                  ENDDO
